

local aSpiderSmokes=30
local boost=1
local aSpiderDrop=0
local aSpiderFrame=1
local aSpiderSize=150
local aSpiderDirection
local aSpiderDistance
local aSpiderAngle
local aSpiderStepSize=7
local aSpiderX
local aSpiderY
local aSpiderDirections={1,2,1,2,0,2,0,1,0,1,0,1,1,0,0,2,0,2,2,0,2,0,1,2,1,2,0,2,1,0,1,2,1}
local aSpiderSmokeTbl={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50}

function aSpiderStep()

  aSpiderDistance=aSpiderDistance-1
  if aSpiderDrop==10 then aSpiderDrop=0 end
  aSpiderDrop=aSpiderDrop+1
  
  if (aSpiderFrame==8) then aSpiderFrame=1 else aSpiderFrame=aSpiderFrame+1 end--if
  
  if (aSpiderDistance<=0) then
    aSpiderDirection=aSpiderDirections[floor(random()*(getn(aSpiderDirections)+1))];
    if (aSpiderDirection==0) then aSpiderDistance=floor(random()*8)+8 else aSpiderDistance=floor(random()*3)+2 end--if
  end--if
  
  if (aSpiderDirection==1) then aSpiderAngle = aSpiderAngle - 5  elseif (aSpiderDirection==2) then aSpiderAngle = aSpiderAngle + 5 end
  if (aSpiderAngle>=360) then aSpiderAngle=aSpiderAngle-360 end
  if (aSpiderAngle<0) then aSpiderAngle=aSpiderAngle+360 end
  
  local speed=1
  local mousedistance=0
  local baseX,baseY=aSpider:GetCenter()
  
  local mouseX,mouseY=GetCursorPosition()
  mouseX=mouseX/UIParent:GetEffectiveScale()
  mouseY=mouseY/UIParent:GetEffectiveScale()
  --print(baseY.." - "..mouseY)
  
  mousedistance=sqrt((abs(mouseX-baseX)*abs(mouseX-baseX))+(abs(mouseY-baseY)*abs(mouseY-baseY)))

  if (mousedistance<=160) then speed=2;boost=1 end
  if (mousedistance<=120) then speed=3;boost=1 end
  if (mousedistance<=80)  then speed=4;boost=1 end
  if (mousedistance<=40)  then speed=5;boost=1 end
  
  
  aSpiderX=aSpiderX+((aSpiderStepSize*speed)*sin(aSpiderAngle))
  aSpiderY=aSpiderY-((aSpiderStepSize*speed)*cos(aSpiderAngle))

  aSpider:SetPoint("CENTER",UIParent,"TOPLEFT",aSpiderX,-aSpiderY)
  aSpiderTexture:SetRotation(rad(-aSpiderAngle))
  aSpiderTexture:SetTexture("Interface\\AddOns\\AnnoyingSpider\\spider"..aSpiderFrame)
  
  
  for i=1,aSpiderSmokes do
	local modd=(i-1)+(aSpiderDrop/10)
	--if i==20 then print(modd) end
	if i==1 then
	  _G["aSpiderSmoke"..aSpiderSmokeTbl[i]]:SetAlpha(modd)
	else
	  _G["aSpiderSmoke"..aSpiderSmokeTbl[i]]:SetAlpha(1-(modd/aSpiderSmokes))
	end
	  _G["aSpiderSmoke"..aSpiderSmokeTbl[i]]:SetWidth((150*(1+(modd/5)))*1.4142109375)
	  _G["aSpiderSmoke"..aSpiderSmokeTbl[i]]:SetHeight((150*(1+(modd/5)))*1.4142109375)
	end--do
	
  if aSpiderDrop==10 then
    _G["aSpiderSmoke"..aSpiderSmokeTbl[aSpiderSmokes]]:SetWidth(1)
	_G["aSpiderSmoke"..aSpiderSmokeTbl[aSpiderSmokes]]:SetHeight(1)
    _G["aSpiderSmoke"..aSpiderSmokeTbl[aSpiderSmokes]]:SetPoint("CENTER",UIParent,"TOPLEFT",aSpiderX,-aSpiderY)
	_G["aSpiderSmoke"..aSpiderSmokeTbl[aSpiderSmokes]]:SetRotation(rad(random()*360))
	local col=0.1+(random()*0.15)
	if boost then col=col+(random()*0.25);boost=nil end
	_G["aSpiderSmoke"..aSpiderSmokeTbl[aSpiderSmokes]]:SetVertexColor(col,col,col,1)
	tinsert(aSpiderSmokeTbl,1,tremove(aSpiderSmokeTbl,aSpiderSmokes))
  end--if
  
    
  
  
  if aSpiderX>UIParent:GetWidth()+75 or aSpiderY>UIParent:GetHeight()+75 or aSpiderX<-75 or aSpiderY<-75 then
	aSpiderReset()
  end--if
end--function

function aSpiderReset()
  --aSpider:SetScale(0.8)
  --print("spider started")
  aSpiderAngle=floor(random()*3.99)*90
  aSpiderDirection=0
  aSpiderDistance=10

  if (aSpiderAngle==0) then --nede
	  aSpiderX=random()*(UIParent:GetWidth() - aSpiderSize);
      aSpiderY=UIParent:GetHeight()+(aSpiderSize/2)
  end--if
  if (aSpiderAngle==90) then --venstre
	  aSpiderX=-(aSpiderSize/2);
      aSpiderY=random()*(UIParent:GetHeight() - aSpiderSize)
  end--if
  if (aSpiderAngle==180) then --oppe
	  aSpiderX=random()*(UIParent:GetWidth() - aSpiderSize);
      aSpiderY=-(aSpiderSize/2)
  end--if
  if (aSpiderAngle==270) then --hyre
	  aSpiderX=UIParent:GetWidth()+(aSpiderSize/2)
      aSpiderY=random()*(UIParent:GetHeight() - aSpiderSize)
  end--if
  aSpiderTexture:SetRotation(rad(-aSpiderAngle))
  aSpiderTexture:SetWidth(256*1.4142109375)
  aSpiderTexture:SetHeight(256*1.4142109375)
  aSpider:SetPoint("CENTER",UIParent,"TOPLEFT",aSpiderX,-aSpiderY)
  if UnitIsAFK("player") then aSpider.running=1 else aSpider.running=0; aSpiderHideSmoke() end
end--function

function aSpiderHideSmoke()
  for i=1,50 do
     _G["aSpiderSmoke"..i]:SetPoint("CENTER",UIParent,"TOPLEFT",-500,500)
  end--do
end--function
